local BoxTallyMode = CrashAddon.BoxTallyMode

local function CompassThinker(mo)
	//failsafe
	if not mo.tracer or not mo.tracer.valid or not mo.tracer.player or not
			BoxTallyMode() or not CrashAddon.globalpointer or not 
			mo.tracer.player.crash_boxpointer or CrashAddon.boxcount <= 0 or
			not CrashAddon.isvalidlevel
		P_RemoveMobj(mo)
		return
	end
	
	local x = mo.tracer.x
	local y = mo.tracer.y
	local z = mo.tracer.z
	//start a search for the closest box to point towards
	local temp
	local closest = INT32_MAX
	for boxes in mobjs.iterate() do
		if not boxes.crashmapbox or boxes.type == MT_NITROBOX
			continue
		end
		local h_dist = R_PointToDist2(x, y, boxes.x, boxes.y)
		temp = R_PointToDist2(0, z, h_dist, boxes.z)
		if temp < closest
			closest = temp
			mo.target = boxes
		end
	end
	if not mo.target or not mo.target.valid
		P_RemoveMobj(mo)
		return
	end
	mo.closedist = closest
	//point towards the closest box
	mo.angle = R_PointToAngle2(x, y, mo.target.x, mo.target.y)
	local hight = mo.tracer.height / 2
	if mo.tracer.eflags & MFE_VERTICALFLIP
		hight = 0
	end
	P_MoveOrigin(mo, x + P_ReturnThrustX(mo, mo.angle, 75 * mo.tracer.scale), 
			y + P_ReturnThrustY(mo, mo.angle, 75 * mo.tracer.scale), z + hight)
	//change the appearance based on distance of closest box
	local blink
	if displayplayer == mo.tracer.player
		if mo.closedist <= 100 * FRACUNIT
			blink = 1
		elseif mo.closedist <= 1000 * FRACUNIT
			mo.color = SKINCOLOR_RED
			mo.scale = mo.tracer.scale
			blink = 3
		elseif mo.closedist <= 3000 * FRACUNIT
			mo.color = SKINCOLOR_TOPAZ
			mo.scale = mo.tracer.scale - (mo.tracer.scale / 4)
			blink = 6
		elseif mo.closedist <= 7500 * FRACUNIT
			mo.color = SKINCOLOR_GREEN
			mo.scale = mo.tracer.scale / 2
			blink = 12
		else
			mo.color = SKINCOLOR_WHITE
			mo.scale = mo.tracer.scale / 4
			blink = 24
		end
		if leveltime % blink == 0
			if blink == 1
				mo.flags2 = $ | MF2_DONTDRAW
			else
				mo.flags2 = $ & ~MF2_DONTDRAW
				if mo.frame & FF_ADD
					mo.frame = $ & ~FF_ADD
				else
					mo.frame = $ | FF_ADD
				end
			end
		end
	else
		mo.flags2 = $ | MF2_DONTDRAW
	end
end

local function CompassSpawner(player)
	if not BoxTallyMode() or not CrashAddon.globalpointer or not 
			player.crash_boxpointer or CrashAddon.boxcount <= 0 or not
			CrashAddon.isvalidlevel
		if player.crash_boxcompass != nil
			player.crash_boxcompass = nil
		end
		return
	end
	
	//spawn in the radar if there isn't one
	if player.crash_boxcompass == nil or not player.crash_boxcompass.valid
		player.crash_boxcompass = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, 
				MT_BOXPOINTER)
		player.crash_boxcompass.tracer = player.mo
	end
end

//hooks
addHook("MobjThinker", CompassThinker, MT_BOXPOINTER)
addHook("PlayerThink", CompassSpawner)