local ObjectSpawner = CrashAddon.ObjectSpawner

local RewardType = {
	MT_EMERALD2, MT_EMERALD3, MT_EMERALD4, MT_EMERALD5, MT_EMERALD6,
	MT_EMERALD7, MT_TOKEN
}
//a rather basic death function for a basic type of box
local function BlankDeath(target)
	if target.crashmapbox
		CrashAddon.boxcount = $ - 1
		target.crashmapbox = nil
	//except this specific blank box is used for handing out rewards
	elseif target.rewardbox
		local reward
		if CrashAddon.boxcount <= 0
			local gem = MT_EMERALD1
			for i, v in ipairs(RewardType)
				if emeralds & (1 << (i - 1))
					gem = v
					break
				end
			end
			reward = ObjectSpawner(target, gem)
			if All7Emeralds(emeralds)
				local addreward = ObjectSpawner(target, MT_TOKEN)
			end
		elseif CrashAddon.boxcount <= CrashAddon.boxtotal / 2
			reward = ObjectSpawner(target, MT_TOKEN)
		else
			return
		end
		target.rewardbox = nil
	end
end

//thinker for the blank box that acts as the reward box
local function RewardBox(mo)
	if mo.rewardbox
		if mo.tracer and mo.tracer.type == MT_SIGN and mo.changepos <= 0
			if CrashAddon.boxtotal > 0
				mo.angle = mo.tracer.angle
				local rewardx = mo.tracer.x + P_ReturnThrustX(mo, mo.angle, 
						150 * mo.scale)
				local rewardy = mo.tracer.y + P_ReturnThrustY(mo, mo.angle, 
						150 * mo.scale)
				P_MoveOrigin(mo, rewardx, rewardy, mo.tracer.z)
				//here's where the total tally gets adjusted for singleplayer
				if not multiplayer
					if CrashAddon.boxtotal >= 50
						CrashAddon.boxtotal = $ / 2
						CrashAddon.boxcount = CrashAddon.boxtotal
					elseif CrashAddon.boxtotal >= 30
						CrashAddon.boxtotal = $ - 10
						CrashAddon.boxcount = CrashAddon.boxtotal
					end
				end
				mo.tracer = nil
				mo.changepos = nil
			else
				P_RemoveMobj(mo)
				return
			end
		elseif mo.changepos
			mo.changepos = $ - 1
		end
		mo.frame = $ | FF_ADD | FF_FULLBRIGHT
	end
end

//hooks
addHook("MobjDeath", BlankDeath, MT_BLANKBOX)
addHook("MobjDeath", BlankDeath, MT_RINGCRATE)
addHook("MobjThinker", RewardBox, MT_BLANKBOX)